<?

/** @global CMain $APPLICATION */

use Bitrix\Main\Loader;

require_once($_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/main/include/prolog_admin_before.php");
require_once($_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/hixload/prolog.php");
require_once($_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/hixload/lib/hiconix.class.php");
if (!defined('LOGFILE')) {
    define('LOGFILE', $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/hixload/logs/hixload.log");
}
if (!defined("DATAFILE")) {
    define("DATAFILE", $_SERVER["DOCUMENT_ROOT"] . '/bitrix/modules/hixload/logs/lastload.php');
}
if (!defined("MAPFILE")) {
    define("MAPFILE", $_SERVER["DOCUMENT_ROOT"] . '/bitrix/modules/hixload/logs/prodmap.php');
}
if (!defined("DIR_IMAGE")) {
    define("DIR_IMAGE", $_SERVER["DOCUMENT_ROOT"] . '/upload/hixload');
}
if (!defined('TEMPLOAD_CMD')) {
    define('TEMPLOAD_CMD', 'php -f ' . $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/hixload/hix_tempload.php > /dev/null 2>&1 &");
}
if (!defined('BASEWRITE_CMD')) {
    define('BASEWRITE_CMD', 'php -f ' . $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/hixload/hix_basewrite.php > /dev/null 2>&1 &");
}
$HIXLOAD_RIGHT = $APPLICATION->GetGroupRight("hixload");
if ($HIXLOAD_RIGHT != "W") $APPLICATION->AuthForm(GetMessage("ACCESS_DENIED"));

// Подключение jQuery
$APPLICATION->AddHeadScript('/bitrix/js/hixload/jquery-3.2.1.min.js');

Loader::includeModule('hixload');
IncludeModuleLangFile($DOCUMENT_ROOT . $SCRIPT_NAME);
$IBLOCK_ID = intval($IBLOCK_ID);
@set_time_limit(0);

$strErrorMessage = "";
$strOKMessage = "";
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_REQUEST["tempload"]) && check_bitrix_sessid()) {

    //Запись параметров и запуск загрузки данных во временный файл
    $tklen = strlen($token);
    if ($tklen < 16 || $tklen > 24) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_TOKEN');
    }
    if (empty($IBLOCK_ID)) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_IBLOCK');
    }
    $empty_load = true;
    foreach ($brands as $br) {
        if (!empty($br['load'])) $empty_load = false;
    }
    if ($empty_load) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_NOLOAD');
    }
    if (strlen($strErrorMessage) <= 0) {
        COption::SetOptionString('hixload', 'brands', json_encode($brands, JSON_UNESCAPED_UNICODE));
        COption::SetOptionString('hixload', 'attributes', json_encode($attributes, JSON_UNESCAPED_UNICODE));
        COption::SetOptionString('hixload', 'token', $token);
        COption::SetOptionString('hixload', 'prefixname', $prefixname);
        COption::SetOptionString('hixload', 'pricebump', $pricebump);
        COption::SetOptionInt('hixload', 'IBLOCK_ID', $IBLOCK_ID);
        if (!empty($update_price)) {
            COption::SetOptionInt('hixload', 'update_price', $update_price);
        } else {
            COption::RemoveOption('hixload', 'update_price');
        }
        if (!empty($update_seo)) {
            COption::SetOptionInt('hixload', 'update_seo', $update_seo);
        } else {
            COption::RemoveOption('hixload', 'update_seo');
        }
        if (!empty($update_desc)) {
            COption::SetOptionInt('hixload', 'update_desc', $update_desc);
        } else {
            COption::RemoveOption('hixload', 'update_desc');
        }
        if (!empty($update_images)) {
            COption::SetOptionInt('hixload', 'update_images', $update_images);
        } else {
            COption::RemoveOption('hixload', 'update_images');
        }
        if (!empty($update_cats)) {
            COption::SetOptionInt('hixload', 'update_cats', $update_cats);
        } else {
            COption::RemoveOption('hixload', 'update_cats');
        }
        $strOKMessage = GetMessage("HIXLOAD_TEMPLOAD");
        $startok = true;
        if (file_exists(LOGFILE)) {
            $log = json_decode(file_get_contents(LOGFILE), true);
            if ($log['code'] == 'LOAD') {
                $startok = false;
            }
        }
        if ($startok) {
            file_put_contents(LOGFILE, json_encode(array('code'=>'LOAD', 'msg' => GetMessage("HIXLOAD_TEMPLOAD")), JSON_UNESCAPED_UNICODE));
            exec(TEMPLOAD_CMD);
            //include $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/hixload/hix_tempload.php";
        }
    }

} elseif ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_REQUEST["basewrite"]) && check_bitrix_sessid()) {

    //Запись параметров и запуск загрузки данных в инфоблок
    $tklen = strlen($token);
    if ($tklen < 16 || $tklen > 24) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_TOKEN');
    }
    if (empty($IBLOCK_ID)) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_IBLOCK');
    }
    $empty_load = true;
    foreach ($brands as $br) {
        if (!empty($br['load'])) $empty_load = false;
    }
    if ($empty_load) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_NOLOAD');
    }
    if (strlen($strErrorMessage) <= 0) {
        COption::SetOptionString('hixload', 'brands', json_encode($brands, JSON_UNESCAPED_UNICODE));
        COption::SetOptionString('hixload', 'attributes', json_encode($attributes, JSON_UNESCAPED_UNICODE));
        COption::SetOptionString('hixload', 'token', $token);
        COption::SetOptionString('hixload', 'prefixname', $prefixname);
        COption::SetOptionString('hixload', 'pricebump', $pricebump);
        COption::SetOptionInt('hixload', 'IBLOCK_ID', $IBLOCK_ID);
        if (!empty($update_price)) {
            COption::SetOptionInt('hixload', 'update_price', $update_price);
        } else {
            COption::RemoveOption('hixload', 'update_price');
        }
        if (!empty($update_seo)) {
            COption::SetOptionInt('hixload', 'update_seo', $update_seo);
        } else {
            COption::RemoveOption('hixload', 'update_seo');
        }
        if (!empty($update_desc)) {
            COption::SetOptionInt('hixload', 'update_desc', $update_desc);
        } else {
            COption::RemoveOption('hixload', 'update_desc');
        }
        if (!empty($update_images)) {
            COption::SetOptionInt('hixload', 'update_images', $update_images);
        } else {
            COption::RemoveOption('hixload', 'update_images');
        }
        if (!empty($update_cats)) {
            COption::SetOptionInt('hixload', 'update_cats', $update_cats);
        } else {
            COption::RemoveOption('hixload', 'update_cats');
        }
        $strOKMessage = GetMessage("HIXLOAD_BASEWRITE");
        $startok = true;
        if (file_exists(LOGFILE)) {
            $log = json_decode(file_get_contents(LOGFILE), true);
            if ($log['code'] == 'LOAD') {
                $startok = false;
            }
        }
        if ($startok) {
            file_put_contents(LOGFILE, json_encode(array('code'=>'LOAD', 'msg' => GetMessage("HIXLOAD_BASEWRITE")), JSON_UNESCAPED_UNICODE));
            exec(BASEWRITE_CMD);
            //include $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/hixload/hix_basewrite.php";
        }
    }

} elseif ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_REQUEST["saveparams"]) && check_bitrix_sessid()) {

    //Запись параметров без запуска загрузки
    $tklen = strlen($token);
    if ($tklen < 16 || $tklen > 24) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_TOKEN');
    }
    if (empty($IBLOCK_ID)) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_IBLOCK');
    }
    $empty_load = true;
    foreach ($brands as $br) {
        if (!empty($br['load'])) $empty_load = false;
    }
    if ($empty_load) {
        $strErrorMessage = GetMessage('HIXLOAD_ERR_NOLOAD');
    }
    if (strlen($strErrorMessage) <= 0) {
        COption::SetOptionString('hixload', 'brands', json_encode($brands, JSON_UNESCAPED_UNICODE));
        COption::SetOptionString('hixload', 'attributes', json_encode($attributes, JSON_UNESCAPED_UNICODE));
        COption::SetOptionString('hixload', 'token', $token);
        COption::SetOptionString('hixload', 'prefixname', $prefixname);
        COption::SetOptionString('hixload', 'pricebump', $pricebump);
        COption::SetOptionInt('hixload', 'IBLOCK_ID', $IBLOCK_ID);
        if (!empty($update_price)) {
            COption::SetOptionInt('hixload', 'update_price', $update_price);
        } else {
            COption::RemoveOption('hixload', 'update_price');
        }
        if (!empty($update_seo)) {
            COption::SetOptionInt('hixload', 'update_seo', $update_seo);
        } else {
            COption::RemoveOption('hixload', 'update_seo');
        }
        if (!empty($update_desc)) {
            COption::SetOptionInt('hixload', 'update_desc', $update_desc);
        } else {
            COption::RemoveOption('hixload', 'update_desc');
        }
        if (!empty($update_images)) {
            COption::SetOptionInt('hixload', 'update_images', $update_images);
        } else {
            COption::RemoveOption('hixload', 'update_images');
        }
        if (!empty($update_cats)) {
            COption::SetOptionInt('hixload', 'update_cats', $update_cats);
        } else {
            COption::RemoveOption('hixload', 'update_cats');
        }
        $strOKMessage = GetMessage('HIXLOAD_OPTIONS_SAVED');
    }
}

if (empty($attributes)) {
    $attributes = json_decode(COption::getOptionString('hixload', 'attributes', ''), true);
}
if (empty($brands)) {
    $brands = json_decode(COption::getOptionString('hixload', 'brands', ''), true);
}
if (empty($token)) {
    $token = COption::getOptionString('hixload', 'token', '');
}
if (empty($pricebump)) {
    $pricebump = COption::getOptionString('hixload', 'pricebump', '1.0000');
}
if (empty($IBLOCK_ID)) {
    $IBLOCK_ID = COption::getOptionInt('hixload', 'IBLOCK_ID', 0);
}
if (empty($update_price)) {
    $update_price = COption::getOptionInt('hixload', 'update_price', 0);
}
if (empty($update_seo)) {
    $update_seo = COption::getOptionInt('hixload', 'update_seo', 0);
}
if (empty($update_desc)) {
    $update_desc = COption::getOptionInt('hixload', 'update_desc', 0);
}
if (empty($update_images)) {
    $update_images = COption::getOptionInt('hixload', 'update_images', 0);
}
if (empty($update_cats)) {
    $update_cats = COption::getOptionInt('hixload', 'update_cats', 0);
}

if (CModule::IncludeModule("iblock")) {
    $fSelectIblockHtml = GetIBlockDropDownList($IBLOCK_ID, 'IBLOCK_TYPE_ID', 'IBLOCK_ID', false, 'class="adm-detail-iblock-types wide"', 'class="adm-detail-iblock-list wide"');
    $sects = CIBlockSection::GetList(
        array("SORT" => "ASC"),
        $arFilter = array('IBLOCK_ID' => $IBLOCK_ID, 'SECTION_ID' => false),
        false,
        array('ID', 'NAME'),
        false
    );
    $fSections = array();
    while ($s = $sects->GetNextElement()) {
        $tmp = $s->GetFields();
        $fSections[$tmp['ID']] = $tmp['NAME'];
    }

    $fFields = array();
    $db_f = CIBlockProperty::GetList(
        array(),
        array('IBLOCK_ID' => $IBLOCK_ID, 'MULTIPLE' => 'N')
    );
    while ($ar_f = $db_f->getNext()) {
        $fFields[$ar_f['ID']] = $ar_f['NAME'];
    }

    $fChars = array();
    $db_f = CIBlockProperty::GetList(
        array(),
        array('IBLOCK_ID' => $IBLOCK_ID, 'MULTIPLE' => 'Y', 'PROPERTY_TYPE' => 'S')
    );
    while ($ar_f = $db_f->getNext()) {
        $fChars[$ar_f['ID']] = $ar_f['NAME'];
    }

    // Prodmap
    $order = false;
    if (isset($_GET['order'])) {
        $order = $_GET['order'];
    }
    $filter_name = false;
    if (isset($_GET['filter_name'])) {
        $filter_name = $_GET['filter_name'];
    }
    $nav = new \Bitrix\Main\UI\AdminPageNavigation("nav-prodmap");
    $filter = array(
        'start' => $nav->getOffset(),
        'limit' => $nav->getLimit(),
    );
    if ($filter_name) {
        $filter['filter_name'] = $filter_name;
    }
    if ($order) {
        $filter['order'] = $order;
    }
    $hixload = new Hiconix();
    $prodmap = $hixload->getProdMap($filter);
    $nav->setRecordCount($prodmap['total']);

} else {
    $strErrorMessage = 'Модуль iblock не установлен!';
}

$APPLICATION->SetTitle(GetMessage('HIXLOAD_TITLE'));
require($_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/main/include/prolog_admin_after.php");

if ($strErrorMessage != '') {
    $message = new CAdminMessage(array('MESSAGE' => $strErrorMessage, 'TYPE' => 'ERROR'));
    echo $message->Show();
}

if ($strOKMessage != '') {
    $message = new CAdminMessage(array('MESSAGE' => $strOKMessage, 'TYPE' => 'OK', 'HTML' => true));
    echo $message->Show();
}

$aTabs = array(
    array("DIV" => "options", "TAB" => 'Настройки', "TITLE" => 'Настройки'),
    array("DIV" => "prodmap", "TAB" => 'Соответствие товаров', "TITLE" => 'Соответствие товаров')
);

$tabControl = new CAdminTabControl("tabControl", $aTabs, false, true);
$tabControl->Begin();

require 'template.php';

require($_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/main/include/epilog_admin.php");