<?php
IncludeModuleLangFile(__FILE__);

if(class_exists("hixload")) return;

Class hixload extends CModule
{
	var $MODULE_ID = "hixload";
	var $MODULE_VERSION;
	var $MODULE_VERSION_DATE;
	var $MODULE_NAME;
	var $MODULE_DESCRIPTION;
	var $MODULE_GROUP_RIGHTS = "Y";
	var $MODULE_CSS;

	function hixload()
	{
		$arModuleVersion = array();

		$path = str_replace("\\", "/", __FILE__);
		$path = substr($path, 0, strlen($path) - strlen("/index.php"));
		include($path."/version.php");

		if (is_array($arModuleVersion) && array_key_exists("VERSION", $arModuleVersion))
		{
			$this->MODULE_VERSION = $arModuleVersion["VERSION"];
			$this->MODULE_VERSION_DATE = $arModuleVersion["VERSION_DATE"];
		}

		$this->MODULE_NAME = GetMessage("HIXLOAD_MODULE_NAME");
		$this->MODULE_DESCRIPTION = GetMessage("HIXLOAD_MODULE_DESCRIPTION");
		$this->MODULE_CSS = "/bitrix/modules/hixload/hixload.css";
	}

	function InstallDB()
	{
		RegisterModule("hixload");
		RegisterModuleDependences('main', 'OnPanelCreate', 'hixload');
		return true;
	}

	function UnInstallDB()
	{
		COption::RemoveOption("hixload");
		UnRegisterModuleDependences('main', 'OnPanelCreate', 'hixload');
		UnRegisterModule("hixload");
		return true;
	}

	function InstallEvents()
	{
		return true;
	}

	function UnInstallEvents()
	{
		return true;
	}

	function InstallFiles()
	{
		if($_ENV["COMPUTERNAME"]!='BX')
		{
			CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/hixload/install/admin", $_SERVER["DOCUMENT_ROOT"]."/bitrix/admin", true, true);
			CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/hixload/install/themes", $_SERVER["DOCUMENT_ROOT"]."/bitrix/themes", true, true);
			CopyDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/hixload/install/js", $_SERVER["DOCUMENT_ROOT"]."/bitrix/js", true, true);
		}
		return true;
	}

	function UnInstallFiles()
	{
		DeleteDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/hixload/install/admin", $_SERVER["DOCUMENT_ROOT"]."/bitrix/admin");
		DeleteDirFilesEx("/bitrix/images/hixload/");
		DeleteDirFilesEx("/bitrix/js/hixload/");
		DeleteDirFiles($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/hixload/install/themes/.default/", $_SERVER["DOCUMENT_ROOT"]."/bitrix/themes/.default");//css
		return true;
	}

	function DoInstall()
	{
		global $DB, $APPLICATION;
		$this->InstallDB();
		$this->InstallFiles();
		$APPLICATION->IncludeAdminFile(GetMessage("HIXLOAD_INSTALL_TITLE"), $_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/hixload/install/step.php");
	}

	function DoUninstall()
	{
		global $APPLICATION, $DB;
		$this->UnInstallFiles();
		$this->UnInstallDB();
		$APPLICATION->IncludeAdminFile(GetMessage("HIXLOAD_UNINSTALL_TITLE"), $_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/hixload/install/unstep.php");
	}
}
